People,

Below I define the property  cong-foo  for the function 
                                  foo : (x y : C) -> ¬ (y ≈ ε) -> C

This means:  "foo  preserves _≈_, with ignoring the third argument".
This meaning is precisely expressed by the signature of  cong-foo
below.
But it is natural to introduce a more generic  Preserves2-3  type
(similar to  _Preserves₂_→_→_...  of the Library)
and to apply its instance
                       Preserves2-3 {_} {_} {_} {A = C} {_} foo _≈_ _≈_
(something of this kind)
in  cong-foo
-- see the commented line of  "Preserves2-3 ...".

But this my usage of  Preserves2-3  is not type-checked.

Can you, please, advise: how to write the thing in a nicer way?

----------------------------------------------------------------------
module Preserves where
open import Foreign.Haskell
open import IO.Primitive
open import Data.String as String using (String; toCostring)
open import Level using (Level; suc; _⊔_)
open import Relation.Nullary.Core using (¬_)
open import Relation.Binary using (Rel)
open import Algebra using (Monoid; module Monoid)

Preserves2-3 : {a b lA : Level} {A : Set a} {B : Set b} -> 
               (A → A → B -> A) → Rel A lA → Set (lA ⊔ (b ⊔ a))

-- "Preserves by first 2 arguments of 3".

Preserves2-3 {_} {_} {_} {A} {B} f _≈_ =
             {x y x' y' : A} -> {z z' : B} -> 
             x ≈ x' → y ≈ y' -> (f x y z) ≈ (f x' y' z')

record Foo (c l : Level) (M : Monoid c l) : Set (suc (c ⊔ l))
  where
  open Monoid M renaming (Carrier to C)
  field  
    foo      : (x y : C) -> ¬ (y ≈ ε) -> C
    cong-foo : (a b a' b' : C) -> (b/=1  : ¬ (b  ≈ ε)) -> 
                                  (b'/=1 : ¬ (b' ≈ ε)) ->
                                  a ≈ a' -> b ≈ b'     ->
                                  (foo a b b/=1) ≈ (foo a' b' b'/=1)
         
               -- Preserves2-3 {_} {_} {_} {A = C} {_} foo _≈_ _≈_

main : IO Foreign.Haskell.Unit
main = putStrLn (toCostring "done")

